/**
 * Created by cuihandong on 10/07/2017.
 */

var EventDispatcher = require("../../common/events/EventDispatcher");

/**
 * EventDispatcher
 */
var eventMgr = EventDispatcher.getInstance();

var once = function(event,callback){
    var bNeedClear = true;
    var handler = function(){
        eventMgr.removeEventListener(event,handler);
        bNeedClear = false;
        callback();
    }
    eventMgr.addEventListener(event,handler);
    var clear_handler = function(){
        if(bNeedClear){
            eventMgr.removeEventListener(event,handler);
        }
    }
    return clear_handler;
}


var FNodeHelper = {
    /**
     * @param timeS 秒
     * @returns {Function}
     */
    delayTime: function(timeS){
        return function(next){
            setTimeout(next,timeS*1000)
        }
    },
    /**
     * 等待事件
     * 开发中，未验证，先不要使用
     * @param event
     * @returns {Function}
     */
    waitEvent : function(event){
        var f = function(next){
            f.clear_handler = once(event,next)
        }
        return f;
    },

    waitEventOrCheckRecord: function(event,target,recordName){
        var f = function(next){
            if(target[recordName]){
                next();
                f.clear_handler = null;
            }
            else{
                f.clear_handler = once(event,next)
            }
        }
        return f;
    },

    listenEvent: function(event){
        return function(next,runtimeObj){
            var handler = function(){

            }
            runtimeObj.eventRecord = runtimeObj.eventRecord || {}
            eventMgr.addEventListener(event,handler);
            next();
        }
    },
    clearEvent: function(){

    }
}

module.exports = FNodeHelper;